      SUBROUTINE TEST()
        USE COMMON_VARS
        IMPLICIT NONE
!$OMP DECLARE TARGET
!$ACC ROUTINE SEQ
        INTEGER I
        I = NR
      END SUBROUTINE TEST


!******************************************************************************!

      PROGRAM TEST_LINK

      USE COMMON_VARS
      USE PARAMETERS

      IMPLICIT NONE

      INTERFACE
        SUBROUTINE TEST()
!$OMP DECLARE TARGET
!$ACC ROUTINE SEQ
        END SUBROUTINE TEST
      END INTERFACE

      REAL    :: XMO(MAX_SOURCE_POSITIONS), DCP(MAX_SOURCE_POSITIONS)
      INTEGER :: IS1(MAX_SOURCE_POSITIONS), IS2(MAX_SOURCE_POSITIONS)

      INTEGER :: X, Y, Z, MAX_X, MAX_Y, MAX_Z, ISOUR

      MAX_X = 3
      MAX_Y = 4
      MAX_Z = 5
      NR    = 6

!$OMP TARGET MAP(TOFROM:IS1,IS2,DCP,XMO)
!$OMP TEAMS DISTRIBUTE PARALLEL DO COLLAPSE(3)
!$ACC PARALLEL LOOP GANG WORKER COLLAPSE(3) INDEPENDENT &
!$ACC COPY(IS1,IS2,DCP,XMO) COPYIN(NR)
      DO X = 1, MAX_X
         DO Y = 1, MAX_Y
            DO Z = 1, MAX_Z

               ISOUR = (X - 1)*MAX_Y*MAX_Z + (Y - 1)*MAX_Z + Z

               XMO(ISOUR) = 1.0
               DCP(ISOUR) = 2.0
               IS1(ISOUR) = 3
               IS2(ISOUR) = 4   * NR

               CALL TEST()
 
            ENDDO  ! End of z loop
         ENDDO     ! End of y loop
      ENDDO        ! End of x loop
!$ACC END PARALLEL LOOP
!$OMP END TEAMS DISTRIBUTE PARALLEL DO
!$OMP END TARGET

      DO X = 1, MAX_X
         DO Y = 1, MAX_Y
            DO Z = 1, MAX_Z

               ISOUR = (X - 1)*MAX_Y*MAX_Z + (Y - 1)*MAX_Z + Z

               WRITE(*, *) 'ISOUR = ', ISOUR, 'XMO = ', XMO(ISOUR), 'DCP = ', DCP(ISOUR), 'IS1 = ', IS1(ISOUR), 'IS2 = ', IS2(ISOUR)
 
            ENDDO  ! End of z loop
         ENDDO     ! End of y loop
      ENDDO        ! End of x loop

      END PROGRAM TEST_LINK

